unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Async32, Menus, Spin, StdCtrls, ExtCtrls, unit15, IniFiles, Switch, unit2,
  unit3,unit4,unit5, Buttons;

type
  TForm1 = class(TForm)
    Comm1: TComm;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Bevel1: TBevel;
    Label9: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    SpinEdit1: TSpinEdit;
    MainMenu1: TMainMenu;
    Setup1: TMenuItem;
    SwitchArray1: TSwitchArray;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit9: TEdit;
    Label15: TLabel;
    Edit10: TEdit;
    Label16: TLabel;
    Edit11: TEdit;
    Label17: TLabel;
    Edit12: TEdit;
    Label18: TLabel;
    Edit13: TEdit;
    Label19: TLabel;
    Edit14: TEdit;
    Label20: TLabel;
    Edit15: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit16: TEdit;
    Label21: TLabel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Timer1: TTimer;
    BitBtn1: TBitBtn;
    Label22: TLabel;
    procedure Setup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Comm1RxChar(Sender: TObject; Count: Integer);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SwitchArray1Switch(Sender: TObject; Switch: Word);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowData;
  end;

type
  TDataPacket = packed record
                  Flags: longint; //First byte used: Each bit is set by one module in the chain
                  BreakerStates: array[0..7] of byte; //One byte per module = 8 breakers
                  FaultStates: array[0..7] of byte; //One byte per module = 8 breakers
                  Currents: array[0..63] of word; //64 currents
                  Voltages: array[0..7] of word; //One per module
                  Doubling,Defaults,Options,WigWagTime,Profile: array[0..7] of byte; //one per module for each
                end;
  ByteArray= array[0..1000] of byte;
  ByteArrayPtr= ^ByteArray;
  BytePointer= ^Byte;

procedure TXCommand(ID,MT: byte; p: BytePointer; l: byte);

var
  Form1: TForm1;
  ComPortOpen,DualLED,BreakerSetupRX,Cancel: boolean;
  CommsPort,PowerOnDefaults,WigWagMode,WigWagTime,FlasherMode: byte;
  BreakerCurrentSet: array[0..7] of word;
  BreakerTimeSet: array[0..7] of byte;
  TXData: array[0..255] of byte;

const
  mask: array[0..7] of byte = (1,2,4,8,16,32,64,128);

implementation

{$R *.DFM}

var
  ProgrammableProfile: boolean;
  RXTimer,RXNodeTimer: byte;

procedure TForm1.Setup1Click(Sender: TObject);
begin
  Form15.ShowModal;
end;

function ExePath : ShortString;
begin
  result:=Application.ExeName;
  while (length(result)>0) and (result[length(result)]<>'\') do dec(result[0]);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  SFile: TIniFile;
begin
  SFile:=TIniFile.Create(ExePath+'ECB.INI');
  CommsPort:=SFile.ReadInteger('Setup','CommsPort',0);
  SFile.Free;
  comm1.Devicename:='COM'+IntToStr(CommsPort+1);
  try
    COMM1.Baudrate:=cbr57600;
    comm1.open;
    ComPortOpen:=true;
  except
    on ECommError do
    begin
      ShowMessage('The selected port COM'+IntToStr(CommsPort+1)+' is not available,'+
      ' please choose another if possible or free this port if it is in use by another application.');
      ComPortOpen:=false;
    end;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  SFile: TIniFile;
begin
  SFile:=TIniFile.Create(ExePath+'ECB.INI');
  SFile.WriteInteger('Setup','CommsPort',CommsPort);
  SFile.Free;
end;

var
  RXState,RXMessageType,RXCKS1,RXCKS2,RXMessageLength: byte;
  RXLength: byte;
  RXPointer: ^Byte;
  DataPacket: TDatapacket;
  RXData,TXBuffer: array[0..255] of byte;
  RXBuffer: array[0..10000] of byte;

procedure TForm1.ShowData;
var
  b,r: byte;
  n,c: longint;
  s: string;
begin
  b:=DataPacket.Flags;
  for n:=0 to 7 do
  begin
    with FindComponent('Shape'+IntToStr(n+1)) as TShape do
    begin
      if b and 1>0 then Brush.color:=clLime else Brush.color:=clRED;
    end;
    b:=b shr 1;
  end;
  r:=SpinEdit1.Value-1;
  if mask[r] and Datapacket.Flags>0 then
  begin
    RXNodeTimer:=10;
    for n:=0 to 7 do
    begin
      if dataPacket.BreakerStates[r] and mask[n]>0 then SwitchArray1.Switch(n,true) else SwitchArray1.Switch(n,false);
      with FindComponent('Shape'+IntToStr(n+9)) as TShape do
        if dataPacket.FaultStates[r] and mask[n]>0 then Brush.color:=clred else Brush.color:=clLime;
      c:=DataPacket.Currents[r*8+n];
      s:=IntToStr(c);
      if length(s)=1 then s:='0'+s;
      Insert('.',s,length(s));
      with findComponent('Edit'+IntToStr(n+1)) as TEdit do
      begin
        Text:=s;
      end;
    end;
    c:=DataPacket.Voltages[r];
    s:=IntToStr(c);
    if length(s)=1 then s:='0'+s;
    Insert('.',s,length(s));
    Edit9.Text:=s;
    case Datapacket.Doubling[r] of
    0: Edit10.text:='8 individual breakers';
    1: Edit10.text:='1+2 are joined';
    2: Edit10.text:='1+2 and 3+4 are joined';
    3: Edit10.text:='1+2+3 are joined';
    4: Edit10.text:='1+2+3 and 5+6 are joined';
    else Edit10.text:='Unknown option'; end;
    s:='';
    for n:=0 to 7 do
    begin
      if DataPacket.Defaults[r] and mask[n]>0 then s:=s+'On ' else s:=s+'Off ';
    end;
    PowerOnDefaults:=Datapacket.Defaults[r];
    Edit11.Text:=s;
    b:=DataPacket.Options[r];
    if b and $4>0 then
    begin
      Edit12.text:='Programmable';
      ProgrammableProfile:=true;
    end else
    begin
      Edit12.Text:='Fixed '+IntToStr(DataPacket.Profile[r]+1);
      ProgrammableProfile:=false;
    end;
    WigWagMode:=b and 3;
    case WigWagMode of
    0: Edit13.Text:='No wigwag enabled';
    1: Edit13.Text:='Wigwag is off';
    2: Edit13.Text:='Wigwag is steady';
    3: Edit13.Text:='Wigwag is flashing';
    end;
    FlasherMode:=(b shr 3) and 3;
    case (b shr 3) and 3 of
    0: Edit14.Text:='No Flasher enabled';
    1: Edit14.Text:='Flasher on breaker 5';
    2: Edit14.Text:='Flasher on breakers 5 and 6';
    end;
    DualLED:=b and $20>0;
    if DualLED then Edit16.text:='Yes' else Edit16.Text:='No';
    WigWagTime:=Datapacket.WigwagTime[r];
    s:=IntToStr(Datapacket.WigwagTime[r]);
    if length(s)=1 then s:='0'+s;
    Insert('.',s,length(s));
    Edit15.Text:=s+' seconds';
  end;
end;

procedure DoBreakerSetupRX;
begin
  move(RXdata[1],BreakerCurrentSet,16);
  move(RXdata[17],BreakerTimeSet,8);
  BreakerSetupRX:=true;
end;

procedure TForm1.Comm1RxChar(Sender: TObject; Count: Integer);
var
  Bytes,RXOut: Integer;
  d: byte;
begin
  if count>10000 then count:=10000;
  Bytes := Comm1.Read(RXBuffer, Count);
  RXOut:=0;
  while Bytes>0 do
  begin
    d:=RXBuffer[RXOut]; inc(RXOut);
    case RXState of
    0: if d=$D5 then RXState:=1;
    1: if d=$82 then RXState:=2 else RXState:=0;
    2: begin
         RXMessageType:=d;
         RXState:=3;
         RXCKS1:=d;
         RXCKS2:=d;
       end;
    3: begin
         RXMessageLength:=d;
         RXCKS1:=RXCKS1+d;
         RXCKS2:=RXCKS2 xor d;
         RXPointer:=@RXData;
         RXLength:=d;
         RXState:=4;
       end;
    4: begin
         RXPointer^:=d;
         RXCKS1:=RXCKS1+d;
         RXCKS2:=RXCKS2 xor d;
         inc(RXPointer);
         dec(RXLength);
         if RXLength=0 then RXState:=5;
       end;
    5: begin
         if d=RXCKS1 then RXState:=6 else RXState:=0;
       end;
    6: begin
         if d=RXCKS2 then
         begin
           RXTimer:=10;
           if RXMessageType=1 then
           begin
             move(RXData,DataPacket,SizeOf(TDataPacket));
             ShowData;
           end else
           if RXMessageType=0 then
           begin
             if RXData[0]=SpinEdit1.Value-1 then DoBreakerSetupRX;
           end;
         end;
         RXState:=0;
       end;
    end;
    dec(Bytes);
  end;
end;

procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with sender as TShape do
  begin
    SpinEdit1.value:=Tag+1;
  end;
end;

procedure MakeChecksum(p: BytePointer; l: word);
var
  cks1,cks2: byte;
begin
  cks1:=0;
  cks2:=0;
  while l>0 do
  begin
    cks1:=cks1+p^;
    cks2:=cks2 xor p^;
    inc(p);
    dec(l);
  end;
  p^:=cks1; inc(p);
  p^:=cks2;
end;

procedure TXCommand(ID,MT: byte; p: BytePointer; l: byte);
begin
  TXBuffer[0]:=$D5;
  TXBuffer[1]:=$82;
  TXBuffer[2]:=MT;
  TXBuffer[3]:=l+1;
  TXBuffer[4]:=ID;
  move(p^,TXBuffer[5],l);
  MakeChecksum(@TXBuffer[2],l+3);
  form1.comm1.write(TXBuffer,l+5+2);
end;

procedure TForm1.SwitchArray1Switch(Sender: TObject; Switch: Word);
var
  b: boolean;
  s,n: word;
begin
  s:=SwitchArray1.GetSwitch(Switch);
  if s=2 then b:=false else b:=true;
  TXData[0]:=Switch;
  if b then TXData[1]:=1 else TXdata[1]:=0;
  TXCommand(SpinEdit1.Value-1,6,@TXdata,2);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  r,b: byte;
begin
  if not ProgrammableProfile then
  begin
    ShowMessage('This can only be set if you have the programmable profile selected on the ECB module');
    exit;
  end;
  r:=SpinEdit1.Value-1;
  b:=Datapacket.Doubling[r];
  inc(b);
  if b>4 then b:=0;
  TXData[0]:=b;
  TXCommand(SpinEdit1.Value-1,7,@TXdata,1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  form2.ShowModal;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  r,b: byte;
begin
  r:=SpinEdit1.Value-1;
  if WigWagMode=0 then TXData[0]:=1 else TXdata[0]:=0;
  TXCommand(SpinEdit1.Value-1,9,@TXdata,1);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  r,b: byte;
begin
  r:=SpinEdit1.Value-1;
  inc(WigWagMode);
  if WigWagMode>3 then WigWagMode:=1;
  TXData[0]:=WigWagMode-1;
  TXCommand(SpinEdit1.Value-1,4,@TXdata,1);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  form3.ShowModal;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  b: byte;
begin
  inc(FlasherMode);
  if FlasherMode>2 then FlasherMode:=0;
  TXData[0]:=FlasherMode;
  TXCommand(SpinEdit1.Value-1,11,@TXdata,1);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if DualLED then TXData[0]:=0 else TXdata[0]:=1;
  TXCommand(SpinEdit1.Value-1,8,@TXdata,1);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  if MessageDlg('Set ECB node '+IntToStr(SpinEdit1.value)+' to factory default ?',MTConfirmation,[mbYes,mbNo],0)=mrYes then
  begin
    TXData[0]:=0;
    TXCommand(SpinEdit1.Value-1,12,@TXdata,1);
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  BreakerSetupRX:=false;
  TXData[0]:=0;
  TXCommand(SpinEdit1.Value-1,13,@TXdata,1);
  Form5.Show;
  Cancel:=false;
  while not BreakerSetupRX and not cancel do
  begin
    Application.ProcessMessages;
  end;
  form5.hide;
  if BreakerSetupRX then form4.ShowModal;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  n: byte;
begin
  if RXTimer>0 then
  begin
    dec(RXTimer);
    if RXTimer=0 then
    begin
      for n:=0 to 7 do
      begin
        with FindComponent('Shape'+IntToStr(n+1)) as TShape do Brush.Color:=clWhite;
      end;
    end;
  end;
  if RXNodeTimer>0 then
  begin
    dec(RXNodeTimer);
    if RXNodeTimer=0 then
    begin
      for n:=0 to 7 do
      begin
        with FindComponent('Shape'+IntToStr(n+9)) as TShape do Brush.Color:=clWhite;
        SwitchArray1.switch(n,false);
        Edit9.text:='';
        Edit10.text:='';
        Edit11.text:='';
        Edit12.text:='';
        Edit13.text:='';
        Edit14.text:='';
        Edit15.text:='';
        Edit16.text:='';
      end;
    end;
  end;
end;

end.
